function y = mtimes(A, x)

bc=A.bc;
eigA=A.eigA;
r=A.radius;

vec_flag=0;
if size(x,2)==1
    vec_flag=1;
    x=reshape(x,A.n,A.m);
end


switch bc
    case 'periodic'
        x=padarray(x,[r,r],'circular','both');
    case 'reflexive'
        x=padarray(x,[r,r],'symmetric','both');
    case 'zero'
        x=padarray(x,[r,r],0,'both');
    otherwise
        error('Unknown bc')
end
y=real(ifft2(eigA.*fft2(x)));
y=y(r+1:end-r,r+1:end-r);
if vec_flag==1
    y=y(:);
end
