function y = mtimes(A, x)
vec_flag=0;

if size(x,2)==1
    vec_flag=1;
    x=reshape(x,A.n,A.m,3);
end
y=zeros(A.n,A.m,3);
bc=A.bc;
switch A. transposeFlag
    case 0
        % Red
        eigA=A.eigA_R;
        r=A.radius_R;
        switch bc
            case 'periodic'
                xR=padarray(x(:,:,1),[r,r],'circular','both');
            case 'reflexive'
                xR=padarray(x(:,:,1),[r,r],'symmetric','both');
            case 'zero'
                xR=padarray(x(:,:,1),[r,r],0,'both');
            otherwise
                error('Unknown bc')
        end
        yR=real(ifft2(eigA.*fft2(xR)));
        yR=yR(r+1:end-r,r+1:end-r);
        % Green
        eigA=A.eigA_G;
        r=A.radius_G;
        switch bc
            case 'periodic'
                xG=padarray(x(:,:,2),[r,r],'circular','both');
            case 'reflexive'
                xG=padarray(x(:,:,2),[r,r],'symmetric','both');
            case 'zero'
                xG=padarray(x(:,:,2),[r,r],0,'both');
            otherwise
                error('Unknown bc')
        end
        yG=real(ifft2(eigA.*fft2(xG)));
        yG=yG(r+1:end-r,r+1:end-r);
        % Blue
        eigA=A.eigA_B;
        r=A.radius_B;
        switch bc
            case 'periodic'
                xB=padarray(x(:,:,3),[r,r],'circular','both');
            case 'reflexive'
                xB=padarray(x(:,:,3),[r,r],'symmetric','both');
            case 'zero'
                xB=padarray(x(:,:,3),[r,r],0,'both');
            otherwise
                error('Unknown bc')
        end
        yB=real(ifft2(eigA.*fft2(xB)));
        yB=yB(r+1:end-r,r+1:end-r);
        % Mix Channels
        y(:,:,1)=A.Mix_channels(1,1)*yR+A.Mix_channels(1,2)*yG+A.Mix_channels(1,3)*yB;
        y(:,:,2)=A.Mix_channels(2,1)*yR+A.Mix_channels(2,2)*yG+A.Mix_channels(2,3)*yB;
        y(:,:,3)=A.Mix_channels(3,1)*yR+A.Mix_channels(3,2)*yG+A.Mix_channels(3,3)*yB;
    case 1
        % Mix Channels
        x(:,:,1)=A.Mix_channels(1,1)*x(:,:,1)+A.Mix_channels(2,1)*x(:,:,2)+A.Mix_channels(3,1)*x(:,:,3);
        x(:,:,2)=A.Mix_channels(1,2)*x(:,:,1)+A.Mix_channels(2,2)*x(:,:,2)+A.Mix_channels(3,2)*x(:,:,3);
        x(:,:,3)=A.Mix_channels(1,3)*x(:,:,1)+A.Mix_channels(2,3)*x(:,:,2)+A.Mix_channels(3,3)*x(:,:,3);
        % Red
        eigA=A.eigA_R;
        r=A.radius_R;
        switch bc
            case 'periodic'
                xR=padarray(x(:,:,1),[r,r],'circular','both');
            case 'reflexive'
                xR=padarray(x(:,:,1),[r,r],'symmetric','both');
            case 'zero'
                xR=padarray(x(:,:,1),[r,r],0,'both');
            otherwise
                error('Unknown bc')
        end
        yR=real(ifft2(eigA.*fft2(xR)));
        y(:,:,1)=yR(r+1:end-r,r+1:end-r);
        % Green
        eigA=A.eigA_G;
        r=A.radius_G;
        switch bc
            case 'periodic'
                xG=padarray(x(:,:,2),[r,r],'circular','both');
            case 'reflexive'
                xG=padarray(x(:,:,2),[r,r],'symmetric','both');
            case 'zero'
                xG=padarray(x(:,:,2),[r,r],0,'both');
            otherwise
                error('Unknown bc')
        end
        yG=real(ifft2(eigA.*fft2(xG)));
        y(:,:,2)=yG(r+1:end-r,r+1:end-r);
        % Blue
        eigA=A.eigA_B;
        r=A.radius_B;
        switch bc
            case 'periodic'
                xB=padarray(x(:,:,3),[r,r],'circular','both');
            case 'reflexive'
                xB=padarray(x(:,:,3),[r,r],'symmetric','both');
            case 'zero'
                xB=padarray(x(:,:,3),[r,r],0,'both');
            otherwise
                error('Unknown bc')
        end
        yB=real(ifft2(eigA.*fft2(xB)));
        y(:,:,3)=yB(r+1:end-r,r+1:end-r);
        
end
if vec_flag==1
    y=y(:);
end